'ATmega32,  2 Touch-Sensoren

$regfile = "m32def.dat"
$crystal = 11059200
$hwstack = 16
$swstack = 32
$framesize = 32
Baud = 9600


Dim D As Integer
Dim T1 As Integer
Dim T2 As Integer


Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls


Declare Sub Touch1
Declare Sub Touch2


Ddrc = 255
Portc = 0


Do
  Touch1
  Touch2
  Locate 1 , 1
  Lcd T1
  Lcd "   "
  Locate 1 , 8
  Lcd T2
  Lcd "   "
  Waitms 500
Loop


Sub Touch1
  For T1 = 1 To 500
    Ddrc.0 = 0                                              'C4 hochohmig
    Portc.1 = 1                                             'C5 high
    Ddrc.1 = 1                                              'C5 niederohmig
    If Pinc.0 = 0 Then Exit For                             'C4 low?
    Ddrc.1 = 0                                              'C5 hochohmig
    Portc.1 = 0                                             'ohne Pullup
    Ddrc.0 = 1
  Next T1                                                   'C4 low
  Portc.0 = 0
  Portc.1 = 0
  Ddrc.0 = 1
  Ddrc.1 = 1
End Sub


Sub Touch2
  For T2 = 1 To 500
    Ddrc.4 = 0                                              'C4 hochohmig
    Portc.5 = 1                                             'C5 high
    Ddrc.5 = 1                                              'C5 niederohmig
    If Pinc.4 = 0 Then Exit For                             'C4 low?
    Ddrc.5 = 0                                              'C5 hochohmig
    Portc.5 = 0                                             'ohne Pullup
    Ddrc.4 = 1
  Next T2                                                   'C4 low
  Portc.4 = 0
  Portc.5 = 0
  Ddrc.4 = 1
  Ddrc.5 = 1
End Sub

End