'ATmega32, Touch 4, Slider mit Mittelwertbildung


$regfile = "m32def.dat"
$crystal = 11059200
$hwstack = 16
$swstack = 32
$framesize = 32
Baud = 9600


Dim D As Integer
Dim T1 As Integer
Dim T2 As Integer
Dim T10 As Integer
Dim T20 As Integer
Dim T11 As Integer
Dim T21 As Integer
Dim T3 As Integer
Dim T4 As Integer
Dim U1 As Integer
Dim U2 As Integer
Dim Pwm1 As Integer
Dim Mittel(20) As Byte
Dim Zeiger As Byte
Dim N As Byte
Dim I As Byte

Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls


Config Timer1 = Pwm , Prescale = 8 , Pwm = 10 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down
Start Timer1

Waitms 1000

Declare Sub Touch1
Declare Sub Touch2


Ddrc = 255
Portc = 0

Touch1
Touch2
T10 = T1
T20 = T2


Do
  Touch1
  Touch2
  T11 = T10 - T1
  T21 = T20 - T2
  T3 = T11 + T21
  If T3 < 5 Then
     T10 = T1
     T20 = T2
     Zeiger = 1
     N = 0
  End If

  If T3 > 10 Then
     T4 = T21 * 120
     T4 = T4 / T3
     T4 = T4 - 10
     If T4 < 5 Then T4 = 0
     If T4 > 100 Then T4 = 100
     Mittel(zeiger) = T4
     If N > 0 Then
       T4 = 0
       For I = 1 To N
         T4 = T4 + Mittel(i)
       Next N
       T4 = T4 / N
     End If
     Zeiger = Zeiger + 1
     If Zeiger > 20 Then Zeiger = 1
     N = N + 1
     If N > 20 Then N = 20
     Pwm1 = T4 * T4
     Pwm1 = Pwm1 / 10
     Pwm1a = Pwm1

    Locate 1 , 4
    Lcd T4
    Lcd "   "
    Waitms 20
  Else
    Waitms 100
  End If

Loop



Sub Touch1
  For T1 = 1 To 500
    Ddrc.0 = 0                                              'C4 hochohmig
    Portc.1 = 1                                             'C5 high
    Ddrc.1 = 1                                              'C5 niederohmig
    If Pinc.0 = 0 Then Exit For                             'C4 low?
    Ddrc.1 = 0                                              'C5 hochohmig
    Portc.1 = 0                                             'ohne Pullup
    Ddrc.0 = 1
  Next T1                                                   'C4 low
  Portc.0 = 0
  Portc.1 = 0
  Ddrc.0 = 1
  Ddrc.1 = 1
End Sub


Sub Touch2
  For T2 = 1 To 500
    Ddrc.4 = 0                                              'C4 hochohmig
    Portc.5 = 1                                             'C5 high
    Ddrc.5 = 1                                              'C5 niederohmig
    If Pinc.4 = 0 Then Exit For                             'C4 low?
    Ddrc.5 = 0                                              'C5 hochohmig
    Portc.5 = 0                                             'ohne Pullup
    Ddrc.4 = 1
  Next T2                                                   'C4 low
  Portc.4 = 0
  Portc.5 = 0
  Ddrc.4 = 1
  Ddrc.5 = 1
End Sub

End